//+------------------------------------------------------------------+
//|                                                  Heiken Ashi.mq4 |
//|                      Copyright c 2004, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//| For Heiken Ashi we recommend next chart settings ( press F8 or   |
//| select on menu 'Charts'->'Properties...'):                       |
//|  - On 'Color' Tab select 'Black' for 'Line Graph'                |
//|  - On 'Common' Tab disable 'Chart on Foreground' checkbox and    |
//|    select 'Line Chart' radiobutton                               |
//+------------------------------------------------------------------+
//|                                   http://www.mt4programming.com/ |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012-2014, MT4Programming"
#property link      "http://www.mt4programming.com/"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Silver
#property indicator_color2 Silver
#property indicator_color3 Silver
#property indicator_color4 Silver
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1

//----
extern color color1 = Silver;
extern color color2 = Silver;
extern color color3 = Silver;
extern color color4 = Silver;

extern color OddRectangleColor = DarkOrange;
extern bool  OddRectangleFill = true;
extern color EvenRectangleColor = Black;
extern bool  EvenRectangleFill = false;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];

double CCOpenBuffer[];
//----
int ExtCountedBars=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM, 0, 1, color1);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM, 0, 1, color2);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM, 0, 1, color3);
   SetIndexBuffer(2, ExtMapBuffer3);
   SetIndexStyle(3,DRAW_HISTOGRAM, 0, 1, color4);
   SetIndexBuffer(3, ExtMapBuffer4);
//----
   SetIndexDrawBegin(0,10);
   SetIndexDrawBegin(1,10);
   SetIndexDrawBegin(2,10);
   SetIndexDrawBegin(3,10);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
   
   SetIndexBuffer(4,CCOpenBuffer);

   SetIndexEmptyValue( 0, 0.0);
   SetIndexEmptyValue( 1, 0.0);
   SetIndexEmptyValue( 2, 0.0);
   SetIndexEmptyValue( 3, 0.0);
   SetIndexEmptyValue( 4, 0.0);
   
//---- initialization done

   DeleteObjectsByPrefix( "rect_");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   DeleteObjectsByPrefix( "rect_");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double haOpen, haHigh, haLow, haClose;
   if(Bars<=10) return(0);
   ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   int pos=Bars-ExtCountedBars-1;
   
   bool isEven = true;
   if( IndicatorCounted() > 0)
      isEven = !IsEvenRect( Time[pos+1]);
   
   while(pos>=0)
     {
      //Heiken-Ashi OPEN
      //haOpen=(ExtMapBuffer3[pos+1]+ExtMapBuffer4[pos+1])/2;
      
      //Heiken-Ashi CLOSE
      //haClose=(Open[pos]+High[pos]+Low[pos]+Close[pos]+Close[pos]+Close[pos])/6;
      
      //---Dragon-Ashi OPEN---
      //Buffer3 sets the retracement
      haOpen = ((ExtMapBuffer3[pos+1]*2.5)+(ExtMapBuffer4[pos+1]*7.5))/10;
      //haOpen = Close[pos+1];
      
      
      //---Dragon-Ashi CLOSE--
      //haClose= (High[pos+4]+Low[pos+4]+High[pos+3]+Low[pos+3]+High[pos+2]+Low[pos+2]+High[pos+1]+Low[pos+1]+Low[pos]+High[pos])/10;
      //haClose = (High[pos]+Low[pos]+High[pos+1]+Low[pos+1])/4;
      haClose = (((Close[pos+1]+Close[pos])/2) + (Close[pos])) /2;
      //haClose = Close[pos];
      
      haHigh=MathMax((High[pos]), MathMax(haOpen, haClose));
      haLow=MathMin((Low[pos]), MathMin(haOpen, haClose));
      
      if (haOpen<haClose) 
        {
         ExtMapBuffer1[pos]=haLow;
         ExtMapBuffer2[pos]=haHigh;
        } 
      else
        {
         ExtMapBuffer1[pos]=haHigh;
         ExtMapBuffer2[pos]=haLow;
        } 
      ExtMapBuffer3[pos]=haOpen;
      ExtMapBuffer4[pos]=haClose;

      if( pos < Bars-11 &&  haOpen > 0.0)
      {
         if( CCOpenBuffer[pos+2] > 0.0)
            CCOpenBuffer[pos] = 0.5 * ( 0.5 * (CCOpenBuffer[pos+2] + ExtMapBuffer4[pos+2]) + ExtMapBuffer4[pos+2]);
         else
            CCOpenBuffer[pos] = haOpen;
         DrawRect( pos, CCOpenBuffer[pos], ExtMapBuffer4[pos], isEven);
         isEven = !isEven;
      }
      
 	   pos--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+
bool IsEvenRect( datetime tm)
{
   string name = RectName( tm, /*isEven*/ true);
   return( ObjectFind( name) >= 0);
}
//+------------------------------------------------------------------+
string RectName( datetime tm, bool isEven)
{
   string name = (isEven) ? 
      StringConcatenate( "rect_e_", TimeToString( tm)) :
      StringConcatenate( "rect_o_", TimeToString( tm));
   
   return( name);
}
//+------------------------------------------------------------------+
void DrawRect( int pos, double price1, double price2, bool isEven)
{
   string name = RectName( Time[pos], isEven);
   if( ObjectFind( name) >=0 )
      ObjectDelete( name);
   
   ObjectCreate( name, OBJ_RECTANGLE, 0, Time[pos+1], price1, Time[pos], price2);
   ObjectSetInteger( 0, name, OBJPROP_COLOR, (isEven) ? EvenRectangleColor : OddRectangleColor);
   ObjectSetInteger( 0, name,OBJPROP_BACK, (isEven) ? EvenRectangleFill : OddRectangleFill);
   //ObjectSetInteger( 0, name,OBJPROP_STYLE,style);
   //ObjectSetInteger( 0, name,OBJPROP_WIDTH,width);
}
//+------------------------------------------------------------------+
//| Delete all objects by their prefix, returns number of deleted objects:
//+------------------------------------------------------------------+
int DeleteObjectsByPrefix( string prefix)
{
	int len = StringLen( prefix);
	int total = ObjectsTotal();
	int qty = 0;
	
	for( int i=total-1 ; i >=0 ; i--)
	{
		string name = ObjectName(i);
		if( 0 == GetLastError())
		{	if( StringLen( name) > len)
			{	if( prefix == StringSubstr( name, 0, len))
				{
					ObjectDelete( name);
					qty++;
		}	}	}		
	}
	
	return( qty);
}
//+------------------------------------------------------------------+